diff --git a/lib/hive/setup/preflight.rb b/lib/hive/setup/preflight.rb
new file mode 100644
index 000000000..0d20633cf
--- /dev/null
+++ b/lib/hive/setup/preflight.rb
@@ -0,0 +1,231 @@
+require "open3"
+
+require "hive"
+require "hive/config"
+
+module Hive
+  module Setup
+    # `hive setup` dependency preflight / diagnostics (U3). One report that
+    # verifies the local-mode toolchain — Ruby 3.4, git, tmux, gh, claude,
+    # codex, Node/npm, qmd, the Rails bundler, and SQLite — with each row
+    # reporting `present`, `missing`, or `version_too_old` plus the exact
+    # fix command.
+    #
+    # Contract (R12): Hive-owned dependencies (qmd, the web bundle) are
+    # bootstrap-eligible elsewhere in setup; EXTERNAL agent CLIs
+    # (`claude`, `codex`, `gh`) are diagnose-only. This class NEVER runs
+    # installers or login flows for them — it prints the fix command and
+    # moves on.
+    #
+    # Rows use the same status vocabulary as `hive doctor`
+    # (present / missing / version_too_old) so tooling can treat both
+    # reports uniformly.
+    class Preflight
+      Row = Struct.new(:name, :status, :message, :fix, :required, keyword_init: true)
+
+      EXIT_SUCCESS = 0
+      EXIT_HARD_FAILURE = 1
+
+      # name → probe definition. `min` enables version_too_old detection;
+      # `required: true` rows fail setup when broken (everything else is a
+      # loud warning). External CLIs carry `diagnose_only: true`.
+      CHECKS = [
+        {
+          name: "ruby", required: true,
+          min: "3.4",
+          version_argv: %w[ruby -v],
+          version_from: /\Aruby (\d+\.\d+\.\d+)/,
+          fix: "install Ruby 3.4 (https://www.ruby-lang.org/en/documentation/installation/)"
+        },
+        {
+          name: "git", required: true,
+          version_argv: %w[git --version],
+          version_from: /\Agit version (\d+\.\d+\.\d+)/,
+          fix: "install git (apt install git / brew install git)"
+        },
+        {
+          name: "bundle", required: true,
+          version_argv: %w[bundle --version],
+          version_from: /\ABundler version (\d+\.\d+\.\d+)/,
+          fix: "gem install bundler"
+        },
+        {
+          name: "tmux", required: false,
+          min: "3.2",
+          version_argv: %w[tmux -V],
+          version_from: /\Atmux (\d+\.\d+)/,
+          fix: "install tmux 3.2+ (apt install tmux / brew install tmux)"
+        },
+        {
+          name: "node", required: false,
+          min: "18",
+          version_argv: %w[node --version],
+          version_from: /\Av(\d+)\.\d+\.\d+/,
+          fix: "install Node.js 18+ (https://nodejs.org) — required for qmd"
+        },
+        {
+          name: "npm", required: false,
+          version_argv: %w[npm --version],
+          version_from: /\A(\d+\.\d+\.\d+)/,
+          fix: "install npm (ships with Node.js: https://nodejs.org)"
+        },
+        {
+          name: "claude", required: false, diagnose_only: true,
+          version_argv: %w[claude --version],
+          version_from: /\A(\d+\.\d+\.\d+)/,
+          min: Hive::MIN_CLAUDE_VERSION,
+          fix: "install claude, then run `claude setup-token` if a token login is wanted"
+        },
+        {
+          name: "codex", required: false, diagnose_only: true,
+          version_argv: %w[codex --version],
+          version_from: /\A(?:codex-cli\s+)?(\d+\.\d+\.\d+)/,
+          fix: "install codex, then run `codex login --device-auth` to authenticate"
+        },
+        {
+          name: "gh", required: false, diagnose_only: true,
+          version_argv: %w[gh --version],
+          version_from: /\Agh version (\d+\.\d+\.\d+)/,
+          fix: "install gh (https://cli.github.com), then run `gh auth login`"
+        },
+        {
+          name: "sqlite3", required: false,
+          version_argv: %w[sqlite3 --version],
+          version_from: /\A(\d+\.\d+\.\d+)/,
+          fix: "install sqlite3 (apt install sqlite3 libsqlite3-dev / brew install sqlite)"
+        }
+      ].freeze
+
+      attr_reader :rows
+
+      def initialize(runner: nil, qmd_finder: nil)
+        @runner = runner || ->(argv) {
+          begin
+            out, _err, status = Open3.capture3(*argv)
+            [ out, status.success? ]
+          rescue Errno::ENOENT, Errno::EACCES
+            # binary not installed / not runnable → the "missing" answer
+            [ "", false ]
+          end
+        }
+        @qmd_finder = qmd_finder || method(:find_qmd)
+        @rows = nil
+      end
+
+      def call
+        @rows = CHECKS.map { |check| check_row(check) }
+        @rows << qmd_row
+        @rows
+      end
+
+      def hard_failures
+        rows.select { |row| row.required && row.status != "present" }.map(&:name)
+      end
+
+      def warnings
+        rows.reject(&:required).select { |row| row.status != "present" }.map(&:name)
+      end
+
+      def render(output = $stdout)
+        width = rows.map { |r| r.name.length }.max
+        rows.each do |row|
+          line = format("  %-#{width}s  %-14s %s", row.name, "[#{row.status}]", row.message)
+          output.puts line
+          if row.status != "present" && row.fix && !row.fix.empty?
+            output.puts format("  %-#{width}s  └─ fix: %s", "", row.fix)
+          end
+        end
+      end
+
+      private
+
+      def check_row(check)
+        out, ok = @runner.call(check.fetch(:version_argv))
+        unless ok
+          return Row.new(
+            name: check.fetch(:name), status: "missing",
+            message: "not found on PATH",
+            fix: check.fetch(:fix), required: check.fetch(:required)
+          )
+        end
+
+        version = out.lines.first.to_s.strip[check.fetch(:version_from), 1]
+        min = check[:min]
+        if min && version && version_lt(version, min)
+          return Row.new(
+            name: check.fetch(:name), status: "version_too_old",
+            message: "#{version} found, #{min}+ required",
+            fix: check.fetch(:fix), required: check.fetch(:required)
+          )
+        end
+
+        message = version ? "version #{version}" : out.lines.first.to_s.strip
+        message += auth_suffix(check) if check.fetch(:name) == "gh"
+        Row.new(
+          name: check.fetch(:name), status: "present",
+          message: message, fix: nil, required: check.fetch(:required)
+        )
+      end
+
+      # Diagnose-only auth probe for gh (R12): report an unauthenticated
+      # CLI loudly, never attempt `gh auth login`. The row stays `present`
+      # — the binary works; only its credentials are missing.
+      def auth_suffix(_check)
+        gh_auth_out, gh_auth_ok = @runner.call(%w[gh auth status])
+        gh_auth_ok ? "" : " — NOT authenticated; fix: gh auth login"
+      rescue StandardError
+        ""
+      end
+
+      def qmd_row
+        qmd = @qmd_finder.call
+        return Row.new(
+          name: "qmd", status: "missing",
+          message: "not installed (Hive-owned; setup can bootstrap it)",
+          fix: 'npm install --global --prefix "${XDG_DATA_HOME:-$HOME/.local/share}/hive/qmd" @tobilu/qmd',
+          required: false
+        ) unless qmd
+
+        Row.new(name: "qmd", status: "present", message: "found at #{qmd}", fix: nil, required: false)
+      end
+
+      # Same resolution order as hive doctor: HIVE_QMD_BIN, PATH, then the
+      # managed prefix install.sh bootstraps into.
+      def find_qmd
+        env_qmd = ENV["HIVE_QMD_BIN"].to_s
+        return env_qmd if !env_qmd.empty? && File.executable?(env_qmd)
+
+        path_qmd = which("qmd")
+        return path_qmd if path_qmd
+
+        data_home = ENV["XDG_DATA_HOME"].to_s.empty? ? File.expand_path("~/.local/share") : ENV["XDG_DATA_HOME"]
+        candidates = [
+          File.join(data_home, "hive", "qmd", "bin", "qmd"),
+          File.expand_path("~/.local/share/hive/qmd/bin/qmd")
+        ]
+        prefix_file = File.join(data_home, "hive", "install-prefix")
+        if File.readable?(prefix_file)
+          prefix = File.read(prefix_file).lines.first.to_s.strip
+          candidates << File.join(prefix, "hive", "qmd", "bin", "qmd") unless prefix.empty?
+        end
+        candidates.find { |candidate| File.file?(candidate) && File.executable?(candidate) }
+      end
+
+      def which(name)
+        ENV["PATH"].to_s.split(File::PATH_SEPARATOR).each do |dir|
+          path = File.join(dir, name)
+          return path if File.file?(path) && File.executable?(path)
+        end
+        nil
+      end
+
+      # Dotted-version compare via Gem::Version (handles "3.2" vs "3.10"
+      # and pre-release suffixes the way bundler does).
+      def version_lt(a, b)
+        Gem::Version.new(a) < Gem::Version.new(b)
+      rescue ArgumentError
+        a.to_s < b.to_s
+      end
+    end
+  end
+end
diff --git a/lib/hive/web/app_provisioner.rb b/lib/hive/web/app_provisioner.rb
new file mode 100644
index 000000000..9a5ef7b27
--- /dev/null
+++ b/lib/hive/web/app_provisioner.rb
@@ -0,0 +1,241 @@
+require "cgi"
+require "digest"
+require "fileutils"
+require "net/http"
+require "tmpdir"
+
+require "hive"
+require "hive/paths"
+
+module Hive
+  module Web
+    # Provisions a version-matched copy of the hivebox Rails web app for
+    # gem installs (U2). The released `hive-cli` gem deliberately does NOT
+    # package web/ (pinned by test/unit/gemspec_test.rb), so a gem-installed
+    # `hive web` has nothing to run outside a source checkout or the Docker
+    # image. This class fills that gap:
+    #
+    #   target dir: ${XDG_DATA_HOME:-~/.local/share}/hive/web-app/<version>
+    #
+    # Sources, in the order `Hive::Commands::Web` consults them:
+    #   1. HIVEBOX_WEB_APP_DIR override (manual escape hatch — handled by
+    #      the caller, never here)
+    #   2. source checkout next to lib/ (handled by the caller)
+    #   3. release asset download: hive-web-<version>.tar.gz (+ .sha256)
+    #      from the GitHub release matching Hive::VERSION
+    #
+    # After extraction the embedded `gem "hive-cli", path: ".."` dependency
+    # is rewritten to point at the installed gem (a downloaded tarball has
+    # no parent checkout), then `bundle install` runs with its path scoped
+    # INSIDE the app dir so nothing leaks into the user's global bundle.
+    #
+    # Failure is always a typed Hive::Error with manual instructions — a
+    # half-provisioned state is impossible because extraction happens into
+    # a temp dir that is renamed into place only after bundling succeeds.
+    class AppProvisioner
+      VERSION_FILE = ".hive-provisioned".freeze
+
+      attr_reader :target_dir
+
+      def initialize(version: Hive::VERSION, data_home: nil, download: nil, runner: nil)
+        @version = version
+        @data_home = data_home || Hive::Paths.data_home
+        @download = download || method(:download_file)
+        @runner = runner || ->(env, *argv) { system(env, *argv) }
+        @target_dir = File.join(@data_home, "web-app", @version)
+      end
+
+      # Returns the provisioned app dir when it exists (idempotent), or nil
+      # when provisioning failed (the error has already been reported via
+      # Hive::Error by the internal steps... no — raises). Raises
+      # Hive::Error on any failure; returns the target dir path on success.
+      def provision
+        return @target_dir if already_provisioned?
+
+        # A leftover incomplete dir from a crashed prior run is safe to
+        # replace: already_provisioned? just said it is not complete.
+        FileUtils.rm_rf(@target_dir)
+        FileUtils.mkdir_p(File.dirname(@target_dir))
+        tarball = fetch_release_asset
+        verify_checksum!(tarball)
+        extract_atomically!(tarball)
+        rewrite_hive_cli_path!
+        bundle_install!
+        mark_provisioned!
+
+        warn "hive web: provisioned web app #{@version} at #{@target_dir}"
+        @target_dir
+      ensure
+        FileUtils.rm_f(tarball) if defined?(tarball) && tarball&.start_with?(Dir.tmpdir)
+      end
+
+      # True when the target dir holds a complete, previously-provisioned
+      # app. Guards idempotent re-runs (`hive setup` twice must not
+      # re-download).
+      def already_provisioned?
+        File.file?(File.join(@target_dir, "config", "application.rb")) &&
+          File.file?(File.join(@target_dir, "bin", "rails")) &&
+          File.file?(File.join(@target_dir, VERSION_FILE))
+      end
+
+      private
+
+      def asset_base_url
+        "https://github.com/#{Hive::REPO_OWNER}/#{Hive::REPO_NAME}/releases/download/v#{@version}"
+      end
+
+      def fetch_release_asset
+        Dir.mktmpdir("hive-web-dl") do |dl_dir|
+          tarball = File.join(dl_dir, "hive-web-#{@version}.tar.gz")
+          begin
+            @download.call("#{asset_base_url}/hive-web-#{@version}.tar.gz", tarball)
+          rescue StandardError => e
+            raise Hive::Error,
+                  "could not download the hive web app (hive-web-#{@version}.tar.gz): " \
+                  "#{e.class}: #{e.message}. Check your network, or point " \
+                  "HIVEBOX_WEB_APP_DIR at an existing Rails app checkout to skip provisioning."
+          end
+          # Copy out of the tmpdir scope so the caller's cleanup doesn't
+          # race the extraction step.
+          keep = File.join(Dir.tmpdir, "hive-web-#{Process.pid}-#{rand(1_000_000)}.tar.gz")
+          FileUtils.cp(tarball, keep)
+          keep
+        end
+      end
+
+      def verify_checksum!(tarball)
+        expected = Dir.mktmpdir("hive-web-sum") do |sum_dir|
+          sums = File.join(sum_dir, "SHA256")
+          begin
+            @download.call("#{asset_base_url}/hive-web-#{@version}.tar.gz.sha256", sums)
+          rescue StandardError => e
+            raise Hive::Error,
+                  "could not download the hive web app checksum (.sha256): #{e.class}: #{e.message}"
+          end
+          File.read(sums).strip.split(/\s+/).first
+        end
+
+        actual = ::Digest::SHA256.file(tarball).hexdigest
+        return if expected && actual == expected.downcase
+
+        raise Hive::Error,
+              "hive web app download failed checksum verification " \
+              "(expected #{expected}, got #{actual}); refusing to install a " \
+              "tampered or corrupted archive. Delete #{@target_dir} and retry."
+      end
+
+      def extract_atomically!(tarball)
+        staging = "#{@target_dir}.staging.#{Process.pid}"
+        FileUtils.rm_rf(staging)
+        FileUtils.mkdir_p(staging)
+        begin
+          ok = @runner.call({}, "tar", "-xzf", tarball, "-C", staging)
+          unless ok
+            raise Hive::Error,
+                  "failed to extract the hive web app archive into #{staging}; " \
+                  "is `tar` available on PATH?"
+          end
+          # Tolerate both a bare app tree and a single top-level directory.
+          src = if File.file?(File.join(staging, "config", "application.rb"))
+                  staging
+                else
+                  entries = Dir.children(staging)
+                  raise Hive::Error, "hive web app archive is missing config/application.rb" unless entries.size == 1
+
+                  File.join(staging, entries.first)
+                end
+          unless File.file?(File.join(src, "config", "application.rb"))
+            raise Hive::Error, "hive web app archive is missing config/application.rb"
+          end
+
+          # provision/ removed any stale target up front, so this rename
+          # lands the extracted tree in place atomically.
+          FileUtils.mv(src, @target_dir)
+          prune_non_runtime_dirs!
+        ensure
+          FileUtils.rm_rf(staging) if File.directory?(staging)
+        end
+      end
+
+      # Dev/test gems and CI configs are stripped from the release tarball at
+      # build time; this is belt-and-braces for archives built by older jobs.
+      def prune_non_runtime_dirs!
+        %w[spec test tmp storage].each do |dir|
+          FileUtils.rm_rf(File.join(@target_dir, dir))
+        end
+      end
+
+      # A downloaded tarball has no parent checkout, but web/Gemfile pins
+      # `gem "hive-cli", path: ".."`. Rewrite it to the installed gem's real
+      # path so `bundle install` resolves.
+      def rewrite_hive_cli_path!
+        gemfile = File.join(@target_dir, "Gemfile")
+        raise Hive::Error, "provisioned web app is missing a Gemfile" unless File.file?(gemfile)
+
+        gem_path =
+          begin
+            Gem::Specification.find_by_name("hive-cli").full_gem_path
+          rescue Gem::LoadError
+            nil
+          end
+        raise Hive::Error,
+              "cannot rewrite the provisioned web app's hive-cli dependency: " \
+              "the hive-cli gem is not installed where Ruby can see it" unless gem_path
+
+        text = File.read(gemfile)
+        rewritten = text.gsub(/gem\s+"hive-cli",\s*path:[^\n]*/,
+                              "gem \"hive-cli\", path: #{gem_path.inspect}")
+        raise Hive::Error, "provisioned web/Gemfile has no hive-cli path dependency to rewrite" if rewritten == text
+
+        File.write(gemfile, rewritten)
+      end
+
+      def bundle_install!
+        env = {
+          "BUNDLE_GEMFILE" => File.join(@target_dir, "Gemfile"),
+          # Scope the bundle INSIDE the app dir — never pollute the user's
+          # global gem home with the web tier's dependency tree.
+          "BUNDLE_PATH" => File.join(@target_dir, ".bundle"),
+          "BUNDLE_APP_CONFIG" => File.join(@target_dir, ".bundle", "config")
+        }
+        ok = @runner.call(env, "bundle", "install")
+        unless ok
+          raise Hive::Error,
+                "bundle install failed for the provisioned web app. Retry manually: " \
+                "cd #{@target_dir} && bundle install (or set HIVEBOX_WEB_APP_DIR to a " \
+                "checkout of web/ matching hive #{@version})."
+        end
+      end
+
+      def mark_provisioned!
+        File.write(File.join(@target_dir, VERSION_FILE), "#{@version}\n")
+      end
+
+      # Minimal HTTPS downloader with redirect following (GitHub release
+      # assets redirect to S3). No third-party deps.
+      def download_file(url, dest)
+        uri = URI.parse(url)
+        redirects = 0
+        loop do
+          response = Net::HTTP.start(uri.host, uri.port, use_ssl: uri.scheme == "https") do |http|
+            request = Net::HTTP::Get.new(uri.request_uri)
+            request["User-Agent"] = "hive-cli/#{Hive::VERSION}"
+            http.request(request)
+          end
+          case response
+          when Net::HTTPRedirection
+            redirects += 1
+            raise Hive::Error, "too many redirects downloading #{url}" if redirects > 5
+
+            uri = URI.parse(response["location"])
+          when Net::HTTPSuccess
+            File.binwrite(dest, response.body)
+            return dest
+          else
+            raise Hive::Error, "HTTP #{response.code} fetching #{url}"
+          end
+        end
+      end
+    end
+  end
+end
diff --git a/test/integration/setup_enroll_test.rb b/test/integration/setup_enroll_test.rb
new file mode 100644
index 000000000..27e1180b8
--- /dev/null
+++ b/test/integration/setup_enroll_test.rb
@@ -0,0 +1,120 @@
+require "test_helper"
+require "hive/commands/init"
+require "hive/commands/setup"
+
+# U6 — `hive setup` leaves the target project enrolled (daemon.enabled:
+# true), reusing Init and the daemon enable machinery; setup adds no new
+# enrollment semantics.
+class SetupEnrollTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_fresh_repo_is_initialised_with_daemon_enabled
+    with_tmp_global_config do |_dir|
+      with_tmp_git_repo do |repo|
+        result = run_setup(project: repo)
+
+        enroll = result.steps.find { |s| s.name == "enroll" }
+        assert_equal "ok", enroll.status, enroll.detail.to_s
+        cfg_path = File.join(repo, ".hive-state", "config.yml")
+        assert File.file?(cfg_path), "setup must have initialised the project"
+        data = YAML.safe_load_file(cfg_path)
+        assert_equal true, data.dig("daemon", "enabled"),
+                     "Init defaults daemon.enabled: true — setup must preserve it"
+      end
+    end
+  end
+
+  def test_legacy_disabled_project_is_flipped_to_enabled
+    with_tmp_global_config do |_dir|
+      with_tmp_git_repo do |repo|
+        capture_io { Hive::Commands::Init.new(repo, force: true).call }
+        flip_daemon_enabled(repo, false)
+
+        result = run_setup(project: repo)
+
+        enroll = result.steps.find { |s| s.name == "enroll" }
+        assert_equal "ok", enroll.status, enroll.detail.to_s
+        data = YAML.safe_load_file(File.join(repo, ".hive-state", "config.yml"))
+        assert_equal true, data.dig("daemon", "enabled"), "a legacy disabled project must be flipped on"
+      end
+    end
+  end
+
+  def test_already_enrolled_project_is_a_noop
+    with_tmp_global_config do |_dir|
+      with_tmp_git_repo do |repo|
+        capture_io { Hive::Commands::Init.new(repo, force: true).call }
+
+        result = run_setup(project: repo)
+        enroll = result.steps.find { |s| s.name == "enroll" }
+        assert_equal "ok", enroll.status
+        assert_match(/already enrolled/, enroll.detail)
+      end
+    end
+  end
+
+  def test_skip_enroll_leaves_the_project_untouched
+    with_tmp_global_config do |_dir|
+      with_tmp_git_repo do |repo|
+        capture_io { Hive::Commands::Init.new(repo, force: true).call }
+        flip_daemon_enabled(repo, false)
+
+        result = run_setup(project: repo, run: [])
+
+        enroll = result.steps.find { |s| s.name == "enroll" }
+        assert_equal "skipped", enroll.status
+        data = YAML.safe_load_file(File.join(repo, ".hive-state", "config.yml"))
+        assert_equal false, data.dig("daemon", "enabled"), "--skip-enroll must not touch project config"
+      end
+    end
+  end
+
+  private
+
+  def flip_daemon_enabled(repo, value)
+    cfg_path = File.join(repo, ".hive-state", "config.yml")
+    text = File.read(cfg_path)
+    raise "fixture expected a daemon block in #{cfg_path}" unless text =~ /^daemon:$/
+
+    lines = text.split("\n", -1)
+    daemon_idx = lines.index { |line| line == "daemon:" }
+    raise "fixture expected a daemon block in #{cfg_path}" unless daemon_idx
+
+    enabled_idx = nil
+    lines[(daemon_idx + 1)..].each_with_index do |line, offset|
+      break unless line.empty? || line.start_with?("#", " ")
+      next if line.empty? || line.lstrip.start_with?("#")
+
+      if line =~ /\A  enabled:/
+        enabled_idx = daemon_idx + 1 + offset
+        break
+      end
+    end
+
+    if enabled_idx
+      lines[enabled_idx] = lines[enabled_idx].sub(/\A(  enabled:[ \t]+).*$/, "\\1#{value}")
+    else
+      lines.insert(daemon_idx + 1, "  enabled: #{value}")
+    end
+    File.write(cfg_path, lines.join("\n"))
+    data = YAML.safe_load_file(cfg_path)
+    assert_equal value, data.dig("daemon", "enabled"), "fixture flip failed"
+  end
+
+  def run_setup(project:, run: %w[enroll])
+    require "hive/commands/init"
+require "hive/commands/setup"
+    command = Hive::Commands::Setup.new(
+      project: project,
+      skip_preflight: !run.include?("preflight"),
+      skip_web_app: !run.include?("web_app"),
+      skip_daemon: !run.include?("daemon"),
+      skip_enroll: !run.include?("enroll"),
+      skip_web: !run.include?("web")
+    )
+    # Everything except enroll runs real external machinery; skip it by
+    # default so this suite stays hermetic.
+    capture_io { command.call }
+    command
+  end
+end
